/* Copyright (C) All Rights Reserved
** Written by Gottem <support@gottem.nl>
** Website: https://gitgud.malvager.net/Wazakindjes/unrealircd_mods
** License: https://gitgud.malvager.net/Wazakindjes/unrealircd_mods/raw/master/LICENSE
*/

// One include for all cross-platform compatibility thangs
#include "unrealircd.h"

#define UMODE_FLAG 'c'
#define MYHEWK HOOKTYPE_PRE_USERMSG // Hooktype to use

#define BACKPORT (UNREAL_VERSION_GENERATION == 4 && UNREAL_VERSION_MAJOR == 0 && UNREAL_VERSION_MINOR < 10)

// Quality fowod declarations
char *commchans_hook_pre_usermsg(aClient *sptr, aClient *to, char *text, int notice);

#if BACKPORT
	static int has_common_channels(aClient *c1, aClient *c2);
#endif

// Muh globals
static ModuleInfo *ccMI = NULL; // Store ModuleInfo so we can use it to check for errors in MOD_LOAD
Hook *commchansHook = NULL; // Da hewk
Umode *commchans_umode = NULL; // Store umode handle
long commchans_extumode = 0; // Store bitwise value latur

// Dat dere module header
ModuleHeader MOD_HEADER(m_message_commonchans) = {
	"m_message_commonchans", // Module name
	"$Id: v1.03 2018/12/01 Gottem$", // Version
	"Adds umode +c to prevent people who aren't in a common channel with you from messaging you", // Description
	"3.2-b8-1", // Modversion, not sure wat do
	NULL
};

// Initialisation routine (register hooks, commands and modes or create structs etc)
MOD_INIT(m_message_commonchans) {
	ccMI = modinfo;
	// Add a global umode (i.e. propagate to all servers), allow anyone to set/remove it on themselves
	commchans_umode = UmodeAdd(modinfo->handle, UMODE_FLAG, UMODE_GLOBAL, 0, NULL, &commchans_extumode);

	commchansHook = HookAddPChar(modinfo->handle, MYHEWK, -100, commchans_hook_pre_usermsg); // High priority lol
	return MOD_SUCCESS; // Let MOD_LOAD handle errors
}

// Actually load the module here (also command overrides as they may not exist in MOD_INIT yet)
MOD_LOAD(m_message_commonchans) {
	// Did the module throw an error during initialisation?
	if(ModuleGetError(ccMI->handle) != MODERR_NOERROR || !commchans_umode || !commchansHook) {
		// Display error string kek
		config_error("A critical error occurred when loading module %s: %s", MOD_HEADER(m_message_commonchans).name, ModuleGetErrorStr(ccMI->handle));
		return MOD_FAILED; // No good
	}

	return MOD_SUCCESS; // We good
}

// Called on unload/rehash obv
MOD_UNLOAD(m_message_commonchans) {
	// Clean up any structs and other shit
	return MOD_SUCCESS; // We good
}

// Actual hewk function m8
char *commchans_hook_pre_usermsg(aClient *sptr, aClient *to, char *text, int notice) {
	if(!sptr || !to || sptr == to || IsULine(sptr) || IsULine(to) || IsOper(sptr) || !IsPerson(sptr) || !IsPerson(to) || !(to->umodes & commchans_extumode) || has_common_channels(sptr, to))
		return text;

	sendnotice(sptr, "*** You need to be on a common channel with %s to privately message them", to->name);
	return NULL;
}

#if BACKPORT
	// Ripped from src/modules/m_who.c with some edits =]]]
	static int has_common_channels(aClient *c1, aClient *c2) {
		Membership *lp;
		Hook *h;
		int j = 0, k = 0;

		for(lp = c1->user->channel; lp; lp = lp->next) {
			if(IsMember(c2, lp->chptr)) {
				if(c1 == c2)
					return 1;

				for(h = Hooks[HOOKTYPE_VISIBLE_IN_CHANNEL]; h; h = h->next) {
					j = (*(h->func.intfunc))(c2, lp->chptr);
					if(j != 0)
						break;
				}

				/* We must ensure that c1 is allowed to "see" c2 */
				if(j != 0 && !(is_skochanop(c2, lp->chptr) || has_voice(c2, lp->chptr)) && !is_skochanop(c1, lp->chptr))
					break;

				return 1;
			}
		}
		return 0;
	}
#endif
